------------------------------------------------------------------
2016-04-23 18:23:19 +0200 Martin Preuss
Prepared release 4.15.3.

------------------------------------------------------------------
2016-04-23 18:21:15 +0200 Martin Preuss
Revert "Bump SONAME because of API changes in previous commit"
This reverts commit e4023dbe6538efa0dad51947492e09e4e031c216.

Since the macros whose removal led to the SONAME bump were added back again,
the SONAME bump can be reverted as well.

------------------------------------------------------------------
2016-04-21 23:38:33 +0200 Elias Oltmanns
MsgEngine: Properly parse messages containing optional fields
Consider the case that a message definition contains two elements (or
groups) with varying multiplicty at the end. If the latter has a
value (or several values, for that matter), this can only be
unambiguously expressed if the former element has a specified maximum
number of repeats and exactly that many delimiters have been provided.
Make the parser rely on (and honour) that requirement.

------------------------------------------------------------------
2016-04-19 20:22:28 +0200 Martin Preuss
Fixed some logical errors in TLS code (thanks to Michael McConville for pointing out).

------------------------------------------------------------------
2016-04-02 03:31:54 +0200 Martin Preuss
Fixed order of header inclusion for AQDatabase-related files.

------------------------------------------------------------------
2016-04-02 03:31:18 +0200 Martin Preuss
Fixed GWEN_TIME representation in typemaker2.
The reason to prefer GWEN_TIME over GWEN_DATE is the time which is
stored in GWEN_TIME in addition to the date. So we need to save and
load the time as well.

------------------------------------------------------------------
2016-04-02 03:29:45 +0200 Martin Preuss
Don't build qt5 gui for my own Makefile targets.

------------------------------------------------------------------
2016-01-20 09:18:45 +0100 Micha Lenk
Fix build when compiling with old GnuTLS version
This got broken by commit f8771f8c.

------------------------------------------------------------------
2016-01-19 20:54:59 +0100 Micha Lenk
Re-add macros for flags related to TLS cipher selection (like Force-SSLv3)
Additionally the deprecated symbols can now get removed during build by
providing -DNO_DEPRECATED_SYMBOLS in CFLAGS. This is intended for test purposes
only.

------------------------------------------------------------------
2016-01-18 14:44:31 +0100 Christian Dávid
Some minor improvements in the Qt5 and Qt4 gui
Really boring and unimportant changes I made while reading.

------------------------------------------------------------------
2016-01-18 14:56:43 +0100 Christian Dávid
Fixe bug in gwengui-qt5-config.cmake
Also shortend it.

------------------------------------------------------------------
2016-01-17 21:27:23 +0100 Micha Lenk
Bump SONAME because of API changes in previous commit

------------------------------------------------------------------
2016-01-17 21:00:56 +0100 Micha Lenk
Cleanup TLS cipher suite handling
The Gwenhywfar TLS cipher handling is now limited to either setting a cipher
priority list via the environment variable GWEN_TLS_CIPHER_PRIORITIES or
otherwise the GnuTLS library default is being used.

------------------------------------------------------------------
2016-01-17 20:46:25 +0100 Micha Lenk
Fix testsuite for the sourceforge server closing the connection prematurely

------------------------------------------------------------------
2016-01-16 23:34:21 +0100 Martin Preuss
Create ca-bundle.crt from latest Mozilla sources.
We use "mk-ca-bundle.pl" from "curl".

------------------------------------------------------------------
2016-01-16 23:11:43 +0100 Martin Preuss
Updated ca-bundle.crt. Need a way to automate this...

------------------------------------------------------------------
2016-01-16 14:45:07 +0100 Martin Preuss
Adapted my Makefile target to allow building of QT5 gui.

------------------------------------------------------------------
2016-01-16 14:44:43 +0100 Martin Preuss
Inserted empty lines.

------------------------------------------------------------------
2016-01-16 14:44:32 +0100 Martin Preuss
Fixed AM_CPPFLAGS in qt5 gui.

------------------------------------------------------------------
2016-01-16 14:43:59 +0100 Martin Preuss
Added .gitignore.

------------------------------------------------------------------
2016-01-16 14:43:47 +0100 Martin Preuss
Added some more files to .gitignore.

------------------------------------------------------------------
2016-01-15 14:00:00 +0100 Christian Dávid
Updated cmake config files
Now targets are used which makes the usage even easier. Version
checking was improved. Backwards compatibility is ensured.

------------------------------------------------------------------
2016-01-13 22:41:45 +0100 Christian Dávid
Added gui frontend for Qt 5
It is based on the Qt 4 gui. Mainly it replaced all occurences of "4" by "5".

------------------------------------------------------------------
2015-12-31 01:59:51 +0100 Martin Preuss
Typemaker2 now also writes APIDOC.
Will probably switch to member grouping.

------------------------------------------------------------------
2015-12-15 15:38:14 +0100 Martin Preuss
Prepared release 4.15.2beta

------------------------------------------------------------------
2015-12-15 10:50:36 +0100 Martin Preuss
No longer use gnutls_protocol_set_priority().

------------------------------------------------------------------
2015-11-09 22:40:21 +0100 Martin Preuss
Prepared release 4.15.1beta.

------------------------------------------------------------------
2015-10-26 19:59:44 +0100 Martin Preuss
TLS: Introduced preprocessor variable "GWEN_TLS_USE_OLD_CODE".
If this variable is defined the old code for TLS  cipher selection  is
used, otherwise the new code is chosen.

The default setting is currenty to use the new code, that works at
least with the NetBank server.

------------------------------------------------------------------
2015-08-05 21:27:33 +0200 Martin Preuss
Prepared Gwenhywfar 4.15.0.

------------------------------------------------------------------
2015-07-18 20:37:42 +0200 Martin Preuss
Added tests for GWEN_PARAM.

------------------------------------------------------------------
2015-07-18 20:37:33 +0200 Martin Preuss
Fixed a typo.

------------------------------------------------------------------
2015-07-18 19:22:08 +0200 Martin Preuss
Modified XML structure use when reading and witing param values.
GWEN_Param_List_WriteValuesToXml() and GWEN_Param_List_ReadValuesFromXml() now
read/write a more compact XML tree.

------------------------------------------------------------------
2015-07-18 19:20:49 +0200 Martin Preuss
Improved GWEN_XMLNode_GetCharValue() and GWEN_XMLNode_SetCharValue().
If "name" is empty data nodes will be read/written directly below the
given node.

------------------------------------------------------------------
2015-07-18 18:24:09 +0200 Martin Preuss
Improved GWEN_PARAMS.
Now we can read and write lists of GWEN_PARAMs. It is now also possible to
read and write values of params only.

Also added API documentation.

------------------------------------------------------------------
2015-07-13 21:36:55 +0200 Micha Lenk
Make contents of listdoc.h reproducible
There is a Debian initiative working on making builds reproducible, i.e. to
make it possible to reproduce byte-for-byte identical binary packages from a
given source. https://wiki.debian.org/ReproducibleBuilds

The contents of listdoc.h is generated by the output of "find include -name
'*.h'". Unfortunately the output of this command depends on readdir()'s output,
which in general is non-deterministic. Under some yet unknown conditions this
can result in unreproducible API documentation for Gwenhywfar. By sorting the
output of "find" the generated API documentation should become reliably
reproducible.

------------------------------------------------------------------
2015-07-13 20:47:21 +0200 Micha Lenk
mklistdoc: Fix minor typo

------------------------------------------------------------------
2015-05-25 18:18:53 +0200 Martin Preuss
Prepared release 4.14.0.

------------------------------------------------------------------
2015-05-23 21:50:30 +0200 Christian Stimming
Fix segfault on windows when using HBCI with keyfile.
Reported by hbrunn on
https://github.com/Gnucash/gnucash-on-windows/pull/5

------------------------------------------------------------------
2015-05-20 23:24:09 +0200 Martin Preuss
Major speedup of GWEN_Directory_GetMatchingFilesRecursively().
Don't check for duplicates when adding files or folders to the file/folder
list. There should be no duplicate entries anyway inside a folder.

------------------------------------------------------------------
2015-05-17 10:22:06 +0200 Micha Lenk
Re-work Compiler Symbol Visibility Check
This was inspired by http://stackoverflow.com/questions/5987219/best-practices-for-probing-for-symbol-visibility-extensions-in-autoconf

------------------------------------------------------------------
2015-05-17 10:18:16 +0200 Micha Lenk
Drop unused autoconf variable gwen_enable_export

------------------------------------------------------------------
2015-05-15 19:29:13 +0000 Micha Lenk
Fix symbol visibilty check for GCC 5.x
GCC 5.x supports the -fvisibility=hidden flag too.

------------------------------------------------------------------
2015-05-14 10:20:12 +0200 Martin Preuss
Revert "Turn compiler warning for implicit function declaration into error."
This reverts commit 9c20b0998c5f5825ede38ff22eb1b5211eda8741 because
"-Werror=implicit-function-declaration" doesn't exist on my
target build system.

------------------------------------------------------------------
2015-05-04 00:00:03 +0200 Micha Lenk
Revert "Disable timestamps in HTML pages generated by Doxygen"
This reverts commit f340c4a44b4f8a5148b02be0598f2ab63c45e924.

Debian's Doxygen as of version 1.8.9.1-3 will have this disabled by default, so
this change is not needed anymore.

------------------------------------------------------------------
2015-04-13 19:47:06 +0200 Micha Lenk
Disable timestamps in HTML pages generated by Doxygen
There is a Debian initiative working on making builds reproducible, i.e. to
make it possible to reproduce byte-for-byte identical binary packages from a
given source. https://wiki.debian.org/ReproducibleBuilds

One reason why Gwenhywfar currently is not reproducible is the use of timestamps
in HTML pages generated by Doxygen. More details about this particular issue
can be found here:
https://wiki.debian.org/ReproducibleBuilds/TimestampsInDocumentationGeneratedByDoxygen

------------------------------------------------------------------
2015-03-15 23:01:22 +0100 Martin Preuss
typemaker2: Added support for _free-hooks, fixed many compiler warnings.
- freeHooks can be used to insert code into the destructor for generated
  types (used in ADCM_IMAGE_DATA of AqRadBase)
- fixed many compiler warnings about defined but unused variables
- fixed type definition for GWEN_BINDATA

------------------------------------------------------------------
2015-03-15 17:04:24 +0100 Martin Preuss
API ADDITION: Added 2 more virtual functions to GWEN_MULTICACHE
Added virtual functions GWEN_MULTICACHE_TYPE_ATTACH_OBJECT_FN() and
GWEN_MULTICACHE_TYPE_FREE_OBJECT_FN(). Those functions have a pointer
to the GWEN_MULTICACHE_TYPE as first argument.

This is needed for AqRadBase's CUDA image cache.

------------------------------------------------------------------
2015-01-04 19:08:05 +0100 Martin Preuss
Added functions GWEN_Param_List_Get/SetCurrentValueAsInt/Double.

------------------------------------------------------------------
2015-01-03 23:47:21 +0100 Martin Preuss
Prepared release 4.13.1

------------------------------------------------------------------
2015-01-03 21:46:19 +0100 Christian Stimming
Add function declaration that was missing in header, as discovered by the additional compiler option.

------------------------------------------------------------------
2015-01-03 21:45:56 +0100 Christian Stimming
Turn compiler warning for implicit function declaration into error.
This avoids running into the error of 769ab05bb3 again.

------------------------------------------------------------------
2015-01-03 21:42:31 +0100 Christian Stimming
Fix function name for systems without <langinfo.h> but with <localcharset.h>
This is a bugfix for 66521660959.

------------------------------------------------------------------
2015-01-02 21:31:10 +0100 Martin Preuss
Prepared release 4.13.0

------------------------------------------------------------------
2014-12-29 07:54:55 +0100 Elias Oltmanns
gui: Restore compilation without libiconv.

------------------------------------------------------------------
2014-12-28 16:20:58 +0100 Elias Oltmanns
gui: Set up charset conversion according to current locale even on Windows
This change is supposed to make locale-aware charset conversion more
portable. In environments lacking the appropriate POSIX interface like
Windows we rely on the capabilities of GNU libiconv.

------------------------------------------------------------------
2014-12-15 22:25:20 +0100 Christian Stimming
Add build directives for travis-ci.org continuous integration testing

------------------------------------------------------------------
2014-12-15 22:48:55 +0100 Christian Stimming
Bugfix from compiler warnings: Use the correct pointer variable.

------------------------------------------------------------------
2014-12-15 22:48:42 +0100 Christian Stimming
Bugfix from compiler warnings: pos variable might be -1, so it must not be unsigned.

------------------------------------------------------------------
2014-12-15 22:48:21 +0100 Christian Stimming
Bugfixes from compiler warnings: Should have been bit operations, not logical operators.

------------------------------------------------------------------
2014-12-15 22:49:34 +0100 Christian Stimming
Avoid compiler warnings (clang): Remove / deactivate unused functions / variables.

------------------------------------------------------------------
2014-12-14 22:15:15 +0100 Christian Stimming
Fix crash in GWEN_Gui_SetCharSet (gnucash bugzilla #741161) that was calling iconv_close on an invalid descriptor.
Fixes the crash introduced in r2297 / f12fd6e1f in April 2014.

------------------------------------------------------------------
2014-11-02 17:00:41 +0100 Martin Preuss
Added functions GWEN_Param_List_GetByName() and GWEN_Param_Tree_GetByName().

------------------------------------------------------------------
2014-10-12 15:17:11 +0200 Martin Preuss
Added .gitignore.

------------------------------------------------------------------
2014-10-12 15:12:22 +0200 Martin Preuss
Merge branch 'master' of https://git.aqbanking.de/git/gwenhywfar

------------------------------------------------------------------
2014-10-06 21:52:22 +0200 Christian Stimming
Re-indentation of source code to get a unified look of the source.
This was done using astyle-2.03 with the following command:

  astyle --style=java --indent=spaces=2 --break-closing-brackets --keep-one-line-blocks --suffix=none --recursive 'src/*.h' 'src/*.c' 'gui/*.h*' 'gui/*.c*'

(The astyle options were carefully chosen to match the
vast majority of the source code. Nevertheless quite some
of the files have a mixed indentation style, which is
now unified.)

------------------------------------------------------------------
2014-09-28 00:03:51 +0200 Christian Stimming
Make GWEN_Error_SimpleToString function available in public interface.
This function is merely a GWEN_Error -> string converter and hence useful
in itself. No extra buffers needed, no extra texts added.

------------------------------------------------------------------
2014-09-27 23:56:47 +0200 Christian Stimming
Fix compiler warnings/errors: "Variable defined but not used"

------------------------------------------------------------------
2014-09-25 21:14:57 +0200 Christian Stimming
Minor error message improvements.

------------------------------------------------------------------
2014-09-17 22:20:11 +0200 Martin Preuss
Merge branch 'master' of https://git.aqbanking.de/git/gwenhywfar

------------------------------------------------------------------
2014-09-17 22:18:55 +0200 Martin Preuss
Fixed a bug with double deallocations in generated *_copy() functions.

------------------------------------------------------------------
2014-09-17 22:18:25 +0200 Martin Preuss
Provide generated files for GWEN_PARAM.
GWEN_PARAM is provided using typemaker2, so in order to make the code
compilable even without typemaker2 already being built we provide the
generated files here as well.

------------------------------------------------------------------
2014-09-17 22:17:22 +0200 Martin Preuss
Added class GWEN_PARAM.
This is used at least by AqRadBase, and probably by my other projects
as well. It can be used to provide descriptions for settings and a framework
to manage those settings.

AqRadBase will use it to manage the settings of ADCM_CONVERTER and
ADCM_OPERATOR classes. Those settings can then be provided in a generic
manner.

------------------------------------------------------------------
2014-09-15 22:01:45 +0200 Christian Stimming
Add configure check for sufficiently new gnutls as otherwise this won't compile.

------------------------------------------------------------------
2014-08-29 21:04:34 +0200 Christian Stimming
Add minor entry to gitignore (and test git access)

------------------------------------------------------------------
2014-08-04 22:47:49 +0200 Martin Preuss
Generic Parser: Added functions to write a parser element tree to XML.
This is an essential function for later use in AqBanking because it will
be used to generate the basic framework of a format definition from an
XML file.

------------------------------------------------------------------
2014-07-25 23:42:21 +0200 Martin Preuss
More work on generic parser.

------------------------------------------------------------------
2014-07-11 23:12:10 +0000 martin
MultiCache: Added missing counter handling.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2338 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-08 18:30:21 +0000 martin
Removed references to new g_parser from gwentest.c
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2337 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-08 12:43:31 +0000 martin
Fixed version string creation.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2336 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-08 12:43:27 +0000 martin
Added .gitignore entries.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2335 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-08 12:32:53 +0000 martin
Added CMake package configuration files
May not work on Mac OSX or Windows because library extensision .so is
hard coded.

From: Christian Dávid <christian-david@web.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2334 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-04 12:33:12 +0000 martin
Export a function which I need in AqRadBase.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2333 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:40:36 +0000 martin
Fixed my latest changes.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2332 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:40:29 +0000 martin
Removed work-in-progress from normal compiling.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2331 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:40:23 +0000 martin
Added built files to EXTRA_DIST.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2330 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:47 +0000 martin
Fix 3rsa test.
From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2329 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:40 +0000 martin
Only generate RSA keys whose modulus length in bits is a multiple of 8
According to the documentation of Libgcrypt, the length in bits
specified when generating key pairs should always be a multiple of 8.
Hence, the usage of GWEN_Crypt_KeyRsa_GeneratePair2() is deprecated.

From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2328 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:32 +0000 martin
Be careful about sign issues when cropping buffers.
From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2327 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:25 +0000 martin
Fix potential overrun in GWEN_Buffer_RemoveRoom()
Also reported and a similar patch provided by
G. Paul Ziemba <pz-aqbanking-user@ziemba.us>.

From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2326 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:19 +0000 martin
Rely on GWEN_Buffer_AllocRoom() to get things right
Checks for overflow and provision for an extra null character are
taken care of in one place and the caller should rely on that.

From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2325 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:11 +0000 martin
Address some confusion about the terminating null character on buffer resize.
From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2324 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:32:04 +0000 martin
Fix enforcement of read-only attribute in operations on Gwen buffers.
From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2323 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:31:56 +0000 martin
Make sure that GWEN_Memory_malloc() never returns NULL.
From: Elias Oltmanns <eo@nebensachen.de>

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2322 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:28:09 +0000 martin
Typemaker2: Improved generating of APIDOC.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2321 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:28:00 +0000 martin
Added functions GWEN_SyncIo_Helper_PartiallyReadFile() and GWEN_SyncIo_Helper_ReadFile()
Partially or completely reading a file is quite often needed, so we now have
functions for that in GWEN.

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2320 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:27:49 +0000 martin
Fixed the description of GWEN_Text_NumToString() and GWEN_Text_StringToDouble()
Actually, we use the locale "C" for number conversion, so the komma is
represented as a decimal point ("."), not as a komma.

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2319 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-07-03 11:27:42 +0000 martin
Added functions GWEN_StringListEntry_SetData() and GWEN_StringList_FindStringEntry()
Actually, GWEN_StringListEntry_SetData() already was declared but not
implemented.

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2318 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-05-30 19:27:34 +0000 martin
Typemaker2: Fixed a bug in virtual function creator.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2317 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-05-21 18:41:04 +0000 martin
Elias Oltmanns: Use the right key size when the modulus of RSA keys is not divisible by 8.
git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2316 70169cfe-8b10-0410-8925-dcb4b91034d8

------------------------------------------------------------------
2014-04-24 19:53:38 +0000 christian
Add first initial checking of the "destFolder" argument
The cmdline argument was added in r1684, but never read so far.
Even though it is now read for writing the .tm2 files, it
is not yet regarded for the actual *.h/*.c files.

git-svn-id: https://devel.aqbanking.de/svn/gwenhywfar/trunk@2315 70169cfe-8b10-0410-8925-dcb4b91034d8
